package ima.uco.fr.nuit.checker;

import ima.uco.fr.nuit.solchecker.ColumnConstraint;
import ima.uco.fr.nuit.solchecker.ConstraintHandler;
import ima.uco.fr.nuit.solchecker.Encart;
import ima.uco.fr.nuit.solchecker.LamourComOjective;
import ima.uco.fr.nuit.solchecker.ObjectiveHandler;
import ima.uco.fr.nuit.solchecker.RowConstraint;

/**
 * Class to check a solution to the problem
 * @author IMAvengers
 *
 */
public class CheckSolutionHandler {
	
	public static void checkSolution(int[][] i){
		Encart s = new Encart(i);
		
		ConstraintHandler ch=new ConstraintHandler();
		ch.addConstraint(new RowConstraint());
		ch.addConstraint(new ColumnConstraint());
		System.out.println("Solution meets constraints:"+ch.checkConstraints(s));
	
		ObjectiveHandler oh=new ObjectiveHandler(new LamourComOjective(1000));
		System.out.println("Objective function value: "+oh.computerOF(s));
	
	}

}
