package ima.uco.fr.nuit.output;
/**
 * 
 * @author IMAvengers
 *
 */
public class LaTeXOutputter {

	/**
	 * Get result matrix in Latex format with binary variables
	 * 
	 * @param s solution matrix
	 * @return out String associate to the matrix
	 */
	public static String getMatrix(int[][] s){

		String out="\\begin{equation}\\notag"+"\n"+"\\left["+"\n"+"\\begin{array}{";
		for(int c=0;c<=s.length;c++){
			out=out.concat("c");
		}
		out=out.concat("}\n");
		for(int i=0; i<s.length; i++){
			for(int j=0; j<s[i].length; j++){
				out=out.concat(String.valueOf(s[i][j]));
				out=out.concat(j<s[i].length-1?"&":"\\\\ \n");
			}
		}
		out=out.concat("\\end{array}\n\\right]\n\\end{equation}");
		return out;

	}

	/**
	 * Get result matrix in Latex format with figures of man and woman
	 * 
	 * @param s solution matrix
	 * @return out String associate to the matrix
	 */
	public static String getFigure(int[][] s){

		String out="\\begin{tabular}{";
		for(int c=0;c<=s.length;c++){
			out=out.concat("c");
		}
		out=out.concat("}\n");
		for(int i=0; i<s.length; i++){
			for(int j=0; j<s[i].length; j++){
				out=out.concat(getIllustration(s[i][j]));
				out=out.concat(j<s[i].length-1?"&":"\\\\ \n");
			}
		}
		out=out.concat("\\end{tabular}");
		return out;

	}
	/**
	 * Get the figure associate to the value (1 or 0)
	 * 
	 * @param value boolean
	 * @return path to the right figure
	 */
	private static String getIllustration(int value){
		return value==1?"\\includegraphics[height=1cm]{./img/w.jpg}":"\\includegraphics[height=1cm]{./img/m.jpg}";
	}

}
