package ima.uco.fr.nuit.solchecker;

import java.util.ArrayList;

/**
 * Handles the problem constraints
 * @author Quentin
 *
 */
public class ConstraintHandler {
	/**
	 * Hold the constraints
	 */
	private ArrayList<Constraint> constraints=new ArrayList<Constraint>();
	/**
	 * Adds a constraint
	 * @param c the constraint to add
	 */
	public void addConstraint(Constraint c){
		this.constraints.add(c);
	}
	/**
	 * Checks the constraints
	 * @param s the solution to check
	 * @return true if the solutionc checks all constraints, false otherwise
	 */
	public boolean checkConstraints(Solution s){
		boolean check=true;
		for(Constraint c:constraints){
			if(!c.checkConstraint(s)){
				System.out.println("constraint on" + c.getClass().getName()+" violated");
				check=false;
			}
		}
		return check;
	}
	
}
