package ima.uco.fr.nuit.solchecker;
/**
 * Models a solution for the "Encart" problem
 * @author Quentin
 *
 */
public class Encart implements Solution{
	/**
	 * Matrix dimension
	 */
	private int size;
	/**
	 * Profile encart
	 */
	private int[][] encart= new int[getSize()][getSize()];
	/**
	 * Class constructor
	 */
	public Encart(){
		//Nothing to implement
	}
	/**
	 * Class constructor
	 * @param encart an encart
	 */
	public Encart(int[][] encart){
		this.encart=encart;
		this.size = encart.length;
	}
	
	/**
	 * sets the value of a profile
	 * @param row the row index
	 * @param column the column index
	 */
	public void setValue(int row, int column, int value) throws IllegalArgumentException{
		assert value==0||value==1;
		this.encart[row][column]=value;
	}
	/**
	 * Returns the value of a profile (i.e., male or female)
	 * @param row the row index
	 * @param column the column index
	 * @return the value in the right cell
	 */
	public int getValue(int row, int column){
		return this.encart[row-1][column-1];
	}
	public int getSize() {
		return size;
	}

}
