package ima.uco.fr.nuit.solchecker;

import java.util.ArrayList;

public class LamourComOjective implements Objective{

	private ArrayList<Double> percentages;
	double revenue=Double.NaN;

	public LamourComOjective(double revenue){
		this.revenue=revenue;
	}
	
	@Override
	public double compute(Solution s) {
		Encart e=(Encart)s;
		this.percentages=new ArrayList<Double>();

		//Case 1:
		for(int k=1; k<=e.getSize();k++){
			int sum=0;
			for(int i=1; i<=k;i++)
				sum+=e.getValue(k+1-i, i);
			double c=(100.00/k)*sum;
			if(!this.percentages.contains(c))
				this.percentages.add(c);
		}

		//Case 2:
		for(int k=e.getSize()+1; k<=2*e.getSize()-1;k++){
			int sum=0;
			for(int i=k-e.getSize(); i<=e.getSize()-1;i++)
				sum+=e.getValue(k-i, i+1);
			double c=(100.00/(2*e.getSize()-k))*sum;
			if(!this.percentages.contains(c))
				this.percentages.add(c);
		}

		//Case 3:
		for(int k=2*e.getSize(); k<=3*e.getSize()-1;k++){
			int sum=0;
			for(int i=1; i<=k-2*e.getSize()+1;i++)
				sum+=e.getValue(i, i-k+3*e.getSize()-1);
			double c=(100.00/(k-2*e.getSize()+1))*sum;
			if(!this.percentages.contains(c))
				this.percentages.add(c);
		}
		//Case 4:
		for(int k=3*e.getSize(); k<=4*e.getSize()-2;k++){
			int sum=0;
			for(int i=k-3*e.getSize()+2; i<=e.getSize();i++)
				sum+=e.getValue(i, i-k+3*e.getSize()-1);
			double c=(100.00/(4*e.getSize()-1-k))*sum;
			if(!this.percentages.contains(c))
				this.percentages.add(c);
		}
		return this.percentages.size()*revenue;
	}
	
	

}
